/*=================================================
            ef[^
=================================================*/
const	NAME_LEN = 10, INFO_LEN = 513;
const	PARAM1 = 0, PARAM2 = 1, TABLE_END = -1;


struct	UNIT_TABLE{
	char	name[ NAME_LEN ];
	char	info[ INFO_LEN ];	
	complex	value;
};

struct	FUNC_TABLE1{
	char	name[ NAME_LEN ];
	complx	(*pFunc)( complx );
	char	info[ INFO_LEN ];	
};

struct	FUNC_TABLE2{
	char	name[ NAME_LEN ];
	complx	(*pFunc)( complx, complx );
	char	info[ INFO_LEN ];	
};


/*=================================================
           ͗pi LA{^ j
=================================================*/
#ifdef	_INIT
int    KEY_CHAR[] = {
	'(', ')', '+', '-', '*', '/', '=', ' ',
	'0', '1', '2', '3',	'4', '5', '6', '7', '8', '9',
	'.', '$'
};	
#else
extern	KEY_CHAR[];
#endif
					  

/*======================================================
                  萔̊Ǘ
======================================================*/
#ifdef	_INIT
UNIT_TABLE	UnitTable[] = {
	{ "i",	"Pʒ萔 iiPʁj",	{ 0,	 1 } },
	{ "p",	"Pʒ萔 pisRj",		{ 1e-12, 0 } },
	{ "n",	"Pʒ萔 niimj",		{ 1e-9,	 0 } },
	{ "u",	"Pʒ萔 ui}CNj",	{ 1e-6,	 0 } },
	{ "m",	"Pʒ萔 mi~j",		{ 1e-3,	 0 } },
	{ "k",	"Pʒ萔 kiLj",		{ 1e3,	 0 } },
	{ "meg","Pʒ萔 megiKj",		{ 1e6,	 0 } },
	{ "g",	"Pʒ萔 giMKj",		{ 1e9,	 0 } },
	{ "t",	"Pʒ萔 tiej",		{ 1e12,	 0 } },
	{ "pi",	"w萔 pii~j",	{ M_PI,	 0 } },
	{ "e",	"w萔 eipΐ̒j",{ M_E,	 0 } },
	{ "" },
};
#else
	extern	UNIT_TABLE	UnitTable[];
#endif


/*======================================================
                  ֐̊Ǘ
======================================================*/

/*------------------------------------------------------
			֐e[uiPj 
------------------------------------------------------*/
#ifdef	_INIT
FUNC_TABLE1	FuncTable1[] = {
		{ "abs",	abs,	"a ̐ΒlԂ܂B" },
		{ "arg",	arg,	"a ̕ΊpԂ܂B" },

		{ "asin",	asin,  	"a ̋t֐lԂ܂B" },
		{ "acos",	acos,	"a ̋t]֐lԂ܂B" },
		{ "atan",	atan, 	"a ̋tڊ֐lԂ܂B" },
		{ "asinh",	asinh,  "a ̋toȐ֐lԂ܂B" },
		{ "acosh",	acosh,	"a ̋toȗ]֐lԂ܂B" },
		{ "atanh",	atanh, 	"a ̋toȐڊ֐lԂ܂B" },

		{ "badr",	badr, 	"΍ɑ΂sǗ(%)Ԃ܂B" },
		{ "ceil",	ceil, 	"_ȉ؂グ܂B" },
		{ "conj",	conj,	"a ̋𕡑fԂ܂B" },
		{ "db",		db,  	"{l̃fVxlԂ܂B" },
		{ "defl",	defl, 	"sǗ(%)ɑ΂΍Ԃ܂B" },
		{ "exp",	exp,  	" a  Ԃ܂B " },

		{ "image",	imag,	"a ̋Ԃ܂B" },
		{ "int",	_int, 	"_ȉ؂̂Ă܂B" },
		{ "ln",		log,  	"a ̎RΐlԂ܂B" },
		{ "log",	log,  	"a ̎RΐlԂ܂B" },
		{ "log10",	log10,  "a ̏pΐlԂ܂B" },
		{ "norm",	norm,	"a ̃mԂ܂B" },
		{ "norm2",	norm2,	"a 2mԂ܂B" },
		{ "real",	real,	"a ̎Ԃ܂B" },
		{ "recip",	recip, 	"a ̋to͂܂B" },

		{ "sin",	sin,  	"a ̐֐lԂ܂B" },
		{ "cos",	cos,  	"a ̗]֐lԂ܂B" },
		{ "tan",	tan, 	"a ̐ڊ֐lԂ܂B" },
		{ "sinh",	sinh,  	"a ̑oȐ֐lԂ܂B" },
		{ "cosh",	cosh,  	"a ̑oȗ]֐lԂ܂B" },
		{ "tanh",	tanh, 	"a ̑oȐڊ֐lԂ܂B" },

		{ "sqrt",	sqrt, 	"a ̕Ԃ܂B" },
		{ "swap",	swap, 	"a = x + i*y Ay + i*x o͂܂B" },
		{ "cswap",	cswap, 	"a = x + i*y Ay - i*x o͂܂B" },
		{ "swapc",	swapc, 	"a = x + i*y A-y + i*x o͂܂B" },
		{ "undb",	undb, 	"fVxl̔{lԂ܂B" },
		{"" }

};

/*------------------------------------------------------
			֐e[ui 2 j 
------------------------------------------------------*/
FUNC_TABLE2	FuncTable2[] = {
		{ "build",	build,	"a + b*i ԂB " },
		{ "dbfrac",	dbfrac,	"f a / b ̃fVxlԂ܂B " },
		{ "estn",	  estn, 	"sǗ(%), ްbOaްԂB" },
		{ "pow",	pow,	"a  b vZ܂B " },
		{ "rtpow",	rtpow,	"rtpow(a, b)  a    b悩Ԃ܂B" },
		{ "unpow",	unpow,	"unpow(a, b)  a  b  悩Ԃ܂B" },
		{ "" }
};

#else
	extern FUNC_TABLE1	FuncTable1[];
	extern FUNC_TABLE2	FuncTable2[];
#endif


/*======================================================
           Z[uE[h̃t@Cgq
======================================================*/
#define	MACRO_FILE	".UMF"
#define	GVAR_FILE	".UVF"
#ifdef	_INIT
	char	FileFilter1[] = {"}Nf[^(*.UMF) |*.UMF||"};	// User Macro Format
	char	FileFilter2[] = {"ϐf[^(*.UWF) |*.UVF||"};		// User Valuable Format
#else
	extern	char	FileFilter1[];
	extern	char	FileFilter2[];
#endif

/*=================================================
           ͗pi LA{^ j
=================================================*/
enum	{	SYNTAX_ERROR,
			ASSIGN_ERROR,
			KAKKO_ERROR,
			FUNC_ERROR1,
			FUNC_ERROR2,
			MACRO_ERROR1,
			MACRO_ERROR2,
			DIVISION_ERROR
};
#ifdef	_INIT
	int	ErrorNumber;
	CString	ErrorToken;
	CString	ErrorMessage[] = { 
		"̍\G[",
		"萔ɂ͒lo܂B",
		"'j'܂B",
		"֐̃p[^ُłB",
		"֐̌ɂ'i'KvłB",
		"}N܂B",
		"}NċAĂ܂B",
		"OŏZ܂B"
	};
#else
	extern	int	ErrorNumber;
	extern	CString	ErrorToken;
	extern	CString	ErrorMessage[];
#endif
