// gvardlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "DT_.h"

#include "complx.h"
#include "nodes.h"

#include "gvardlg.h"
#include "Data.h"



#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGvarDlg _CAO


CGvarDlg::CGvarDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGvarDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGvarDlg)
	m_EditBox_Real = _T("");
	m_EditBox_Image = _T("");
	m_Info = _T("");
	//}}AFX_DATA_INIT
}


void CGvarDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGvarDlg)
	DDX_Text(pDX, IDC_GVAR_EDIT1, m_EditBox_Real);
	DDX_Text(pDX, IDC_GVAR_EDIT2, m_EditBox_Image);
	DDX_Text(pDX, IDC_GVAR_INFO, m_Info);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGvarDlg, CDialog)
	//{{AFX_MSG_MAP(CGvarDlg)
	ON_LBN_SELCHANGE(IDC_GVAR_LIST, OnSelchangeGvarList)
	ON_BN_CLICKED(IDC_GVAR_ASSIGN, OnGvarAssign)
	ON_LBN_DBLCLK(IDC_GVAR_LIST, OnDblclkGvarList)
	ON_BN_CLICKED(IDC_GVAR_DELETE, OnGvarDelete)
	ON_BN_CLICKED(IDC_GVAR_LOAD, OnGvarLoad)
	ON_BN_CLICKED(IDC_GVAR_SAVE, OnGvarSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/***************************************************************
[֐] GetListBoxText
[  ] protected
[ @\ ] Xg{bNX̑IĂeLXgpBuffɊi[
         ʏ TRUE AIĂȂꍇ FALSE ԂB
***************************************************************/
BOOL CGvarDlg::GetListBoxText( char* pbuff ) 
{
	int	index = (int)SendDlgItemMessage( IDC_GVAR_LIST,  LB_GETCURSEL, 0, 0 );
	if( index >= 0 ) {
		SendDlgItemMessage( IDC_GVAR_LIST,  LB_GETTEXT, index, ( LONG )( LPSTR )pbuff );
		return	TRUE;
	}else	return FALSE;
}

/***************************************************************
[֐] OutGvarList
[  ] protected
[ @\ ] Xg{bNXɕϐꗗ\
***************************************************************/
int 	CGvarDlg::OutGvarList() 
{
	Id	id("i");
	CString	name;	complx	value;

	SendDlgItemMessage( IDC_GVAR_LIST, LB_RESETCONTENT, 0,0 );
	int	loop = 0;
	while( id.GetGvarData( loop, &name, &value ) == TRUE  ) {	
		SendDlgItemMessage( IDC_GVAR_LIST, LB_INSERTSTRING, loop,
		(LONG)(LPSTR)(const char *) name );
		loop++;
	}
	return loop;
}

/////////////////////////////////////////////////////////////////////////////
// CGvarDlg bZ[W nh

/***************************************************************
[֐] OnInitDialog
[  ] protected
[ @\ ] _CAȌ
***************************************************************/
BOOL CGvarDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɂ̑̏pR[hǉĂB
	OutGvarList();
	return TRUE;
}

/***************************************************************
[֐] OnSelchangeGvarList iXg{bNX̑IύXj
[  ] protected
[ @\ ] IĂϐ̒l\
***************************************************************/
void CGvarDlg::OnSelchangeGvarList() 
{
	// TODO: ̈ʒuɃRg[ʒmnh̃R[hǉĂ
	const FLOAT_MAX = 10;
	if( GetListBoxText( pBuff ) == TRUE ) {
		Id	id( pBuff );
		complx	value = id.eval();
		_gcvt( value.Real(),  FLOAT_MAX, pBuff );
		m_EditBox_Real = pBuff;		
		_gcvt( value.Image(), FLOAT_MAX, pBuff );
		m_EditBox_Image = pBuff;		

		m_Info = id.GetGvarInfo();
	}
	UpdateData( FALSE );
}


/***************************************************************
[֐] OnGvarAssign iATC{^ENbNj
[  ] protected
[ @\ ] ϐ̒liAjGfBbg{bNX̒lϐɑB
         萔̏ꍇ͏oȂB
***************************************************************/
void CGvarDlg::OnGvarAssign() 
{
	// TODO: ̈ʒuɃRg[ʒmnh̃R[hǉĂ
	if( GetListBoxText( pBuff ) == TRUE ) {
		Id	id( pBuff );
		char	*p1, *p2;
		UpdateData( TRUE );
		complx	value( 	strtod( (const char *)m_EditBox_Real, &p1 ),
						strtod( (const char *)m_EditBox_Image,&p2 )		);

		if( *p1 == '\0' && *p2 == '\0' ) {
			if( id.GetAttrib() == GVAR )
				id.set( value );							// 
			else {
				CString	UnitStr = id.GetGvarInfo();
				UnitStr += " ɂ͒lo܂B";
		 		MessageBox( UnitStr, "G[" ); 						// s
			}
		}
	}else {
		m_EditBox_Real.Empty();		m_EditBox_Image.Empty();
	}
	OnSelchangeGvarList();
}


/***************************************************************
[֐] OnOK iOK{^ENbNj
[  ] protected
[ @\ ] pBuff ɑIꂽϐi[ďI
***************************************************************/
void CGvarDlg::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	GetListBoxText( pBuff );
	CDialog::OnOK();
}

/***************************************************************
[֐] OnDblclkGvarList( Xg{bNXE_uNbN )
[  ] protected
[ @\ ] OnOK Ăяo
***************************************************************/
void CGvarDlg::OnDblclkGvarList() 
{
	// TODO: ̈ʒuɃRg[ʒmnh̃R[hǉĂ
	OnOK();	
}

/***************************************************************
[֐] OnGvarDelete() i폜{^NbNj
[  ] protected
[ @\ ] IꂽϐXg폜B
***************************************************************/
void CGvarDlg::OnGvarDelete() 
{
	// TODO: ̈ʒuɃRg[ʒmnh̃R[hǉĂ
	GetListBoxText( pBuff );
	Id	id( pBuff );
	if( id.GetAttrib() == GVAR ) {
		CString	UnitStr  = "ϐ ";
		UnitStr += pBuff;
		UnitStr += " 폜܂B";
		if( MessageBox( UnitStr, "ϐ̍폜", MB_OKCANCEL ) == IDOK )
			if( id.DeleteGvar( pBuff ) == TRUE )OutGvarList();	
	}else {
		CString	UnitStr = id.GetGvarInfo();
		UnitStr += " ͍폜o܂B";
 		MessageBox( UnitStr, "G[" ); 						// s
	}
}


/***************************************************************
[֐] OnGvarLoad
[  ] protected
[ @\ ] ϐ[h
***************************************************************/
void CGvarDlg::OnGvarLoad() 
{
	// TODO: ̈ʒuɃRg[ʒmnh̃R[hǉĂ
	CFileDialog	FileDlg( TRUE, NULL,NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, FileFilter2 );
	if( FileDlg.DoModal() == TRUE ) {
		CFile	File( FileDlg.GetPathName(), CFile::modeRead );

		CString	name;
		char	c;
		double	x, y;		
		int	FileEnd;
		while(1){
			name.Empty();	x = 0;	y = 0;
			if( File.Read( &c, 1 ) ) {
				name += c;
				while( 1 ) {
					File.Read( &c, 1 );
					if( c == '\0' )break;
					name += c;
 				}
				File.Read( &x, sizeof(double) );			
				FileEnd =  File.Read( &y, sizeof(double) );			
				Id	id( (char *)(const char *)name );
				id.set( complx( x, y ) );						
			}else break;
		};
 		OutGvarList(); 
	}
}

/***************************************************************
[֐] OnGvarSave
[  ] protected
[ @\ ] ϐZ[u
***************************************************************/
void CGvarDlg::OnGvarSave() 
{
	// TODO: ̈ʒuɃRg[ʒmnh̃R[hǉĂ
	CFileDialog	FileDlg( FALSE, NULL,NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, FileFilter2 );
	if( FileDlg.DoModal() == TRUE ) {
		CString	FileName = FileDlg.GetPathName();
		if( FileDlg.GetFileExt() == "" )FileName += GVAR_FILE;

		CFile	File( FileName, CFile::modeCreate | CFile::modeWrite );
		int loop = 0;
		CString	name;
		complx	value;
		Id	id;
		double	x,y;

		while( id.GetGvarData( loop, &name, &value )  ) {	
			Id	id( (char *)(const char *)name );
			if( id.GetAttrib() != GVAR )break;

			x = value.Real();	y = value.Image();
			File.Write( (const char *)name, name.GetLength()+1 );
			File.Write( &x, sizeof(double) );
			File.Write( &y, sizeof(double) );
			loop++;
		}
	}	
}
