// macrodlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "DT_.h"

#include "complx.h"
#include "UserMac.h"
#include "MacEdDlg.h"
#include "macrodlg.h"
#include "Data.h"


#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

#define	ERROR_MESSAGE01	"Macro Name Error !" 

/////////////////////////////////////////////////////////////////////////////
// CMacroDlg _CAO


CMacroDlg::CMacroDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMacroDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMacroDlg)
	m_MacroInfo = _T("");
	//}}AFX_DATA_INIT
}


void CMacroDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMacroDlg)
	DDX_Text(pDX, IDC_MACRO_INFO, m_MacroInfo);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMacroDlg, CDialog)
	//{{AFX_MSG_MAP(CMacroDlg)
	ON_BN_CLICKED(IDC_MACRO_DELETE, OnMacroDelete)
	ON_BN_CLICKED(IDC_MACRO_EDIT, OnMacroEdit)
	ON_LBN_DBLCLK(IDC_MACRO_LIST1, OnDblclkMacroList1)
	ON_BN_CLICKED(IDC_MACRO_LOAD, OnMacroLoad)
	ON_BN_CLICKED(IDC_MACRO_SAVE, OnMacroSave)
	ON_BN_CLICKED(IDC_NEWMACRO_EDIT, OnNewmacroEdit)
	ON_LBN_SELCHANGE(IDC_MACRO_LIST1, OnSelchangeMacroList1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/***************************************************************
[֐] OutMacroList
[  ] protected
[ @\ ] `Ă}NXg{bNXɒǉ
***************************************************************/
int CMacroDlg::OutMacroList() 
{
	int	loop = 0;
	CString	name, code;

	SendDlgItemMessage( IDC_MACRO_LIST1, LB_RESETCONTENT, 0,0 );
	while( pUserMacro->GetMacroInfo( loop, &name, &code )) {
		SendDlgItemMessage( IDC_MACRO_LIST1, LB_INSERTSTRING, loop,
			(LONG)(LPSTR)(const char *)name );
		loop++;
	}
	return	loop;	
}

/***************************************************************
[֐] GetListBoxText
[  ] protected
[ @\ ] Xg{bNX̑IĂeLXgpBuffɊi[
         ʏ TRUE AIĂȂꍇ FALSE ԂB
***************************************************************/
BOOL CMacroDlg::GetListBoxText( char* pBuff ) 
{
	int	index = (int)SendDlgItemMessage( IDC_MACRO_LIST1,  LB_GETCURSEL, 0, 0 );
	if( index >= 0 ) {
		SendDlgItemMessage( IDC_MACRO_LIST1,  LB_GETTEXT, index, ( LONG )( LPSTR )pBuff );
		return	TRUE;
	}else	return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// CMacroDlg bZ[W nh

/***************************************************************
[֐] OnInitDialog
[  ] protected
[ @\ ] Xg{bNXɃ}Nꗗ\
***************************************************************/
BOOL CMacroDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	// TODO: ̈ʒuɂ̑̏pR[hǉĂB
	OutMacroList();	
	return TRUE;
}

/***************************************************************
[֐] OnMacroEdit i}N̕ҏW{^ENbNj
[  ] protected
[ @\ ] Iꂽ}N}NҏW_CAOŕҏWAXVB
         }NςȎ̓bZ[W{bNXoB
***************************************************************/
void CMacroDlg::OnMacroEdit() 
{
	// TODO: ̈ʒuɃRg[ʒmnh̃R[hǉĂ
	CMacEdDlg	EditDlg;
	if( GetListBoxText(Buff) == TRUE ) {
		EditDlg.m_MacroName = Buff;
		pUserMacro->GetMacro( EditDlg.m_MacroName, &EditDlg.m_MacroCode, &EditDlg.m_MacroInfo );
		if( EditDlg.DoModal() == TRUE ) {
			if( pUserMacro->MakeMacro( EditDlg.m_MacroName, EditDlg.m_MacroCode, EditDlg.m_MacroInfo ) == TRUE )OutMacroList();
			else MessageBox( ERROR_MESSAGE01 );
		}
	}
}

/***************************************************************
[֐] OnNewmacroEdit iVKҏW{^ENbNj
[  ] protected
[ @\ ] V}N}NҏW_CAOŕҏWAo^B
         }NςȎ̓bZ[W{bNXoB
***************************************************************/
void CMacroDlg::OnNewmacroEdit() 
{
	// TODO: ̈ʒuɃRg[ʒmnh̃R[hǉĂ
	CMacEdDlg	EditDlg;
	if( EditDlg.DoModal() == TRUE ) {
		if( pUserMacro->MakeMacro( EditDlg.m_MacroName, EditDlg.m_MacroCode, EditDlg.m_MacroInfo ) == TRUE )OutMacroList();
		else MessageBox( ERROR_MESSAGE01 );
	}	
}

/***************************************************************
[֐] OnMacroDeletei}N̍폜{^ENbNj
[  ] protected
[ @\ ] Iꂽ}N폜B
***************************************************************/
void CMacroDlg::OnMacroDelete() 
{
	CMacEdDlg	EditDlg;
	if( GetListBoxText(Buff) == TRUE ) {
		CString	MacroStr  = "}N ";
		MacroStr += Buff;
		MacroStr += " 폜܂B";
		if( MessageBox( MacroStr, "}N̍폜", MB_OKCANCEL ) == IDOK ) {
			pUserMacro->DeleteMacro( Buff );
			OutMacroList();
		}
	}
}

/***************************************************************
[֐] OnMacroLoadiLOAD{^ENbNj
[  ] protected
[ @\ ] t@C_CAOœꂽt@C̃t@C
         }N`ǂݍ݁AǉB
***************************************************************/
void CMacroDlg::OnMacroLoad() 
{
	// TODO: ̈ʒuɃRg[ʒmnh̃R[hǉĂ
	CFileDialog	FileDlg( TRUE, NULL,NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, FileFilter1 );
	if( FileDlg.DoModal() == TRUE ) {
		CFile	File( FileDlg.GetPathName(), CFile::modeRead );

		// LɂƑÕ}N񂪃LZ܂A
		//pUserMacro->AllDelete();		
		
		CString	name, code, info;
		int	FileEnd = 1;
		while( FileEnd ) {
			ReadString( &File, &name ); 
			ReadString( &File, &code ); 
			info.Empty();
			FileEnd = ReadString( &File, &info ); 
			pUserMacro->MakeMacro( name, code, info );
		} 
		OutMacroList();
	}	
}

/***************************************************************
[֐] ReadString
[  ] protected
[ @\ ] pFilẽt@CPǂݍ݁ApString Ɋi[B
         t@CGhɓB 0 ԂB
***************************************************************/
int	CMacroDlg::ReadString( CFile* pFile, CString* pString  ) 
{
	char	c;
	int	FileEnd = 1;
	pString->Empty();
	while( FileEnd ) {
		FileEnd = pFile->Read( &c, 1 );
		if( c == '|' )break;		
		*pString += c;
	}
	return	FileEnd;
}


/***************************************************************
[֐] OnMacroSave i SVAE {^ENbNj
[  ] protected
[ @\ ] t@C_CAOœꂽt@C̃t@C
         }N`ށB
***************************************************************/
void CMacroDlg::OnMacroSave() 
{
	// TODO: ̈ʒuɃRg[ʒmnh̃R[hǉĂ
	CFileDialog	FileDlg( FALSE, NULL,NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, FileFilter1 );
	if( FileDlg.DoModal() == TRUE ) {
		CString	FileName = FileDlg.GetPathName();
		if( FileDlg.GetFileExt() == "" )FileName += MACRO_FILE;

		CFile	File( FileName, CFile::modeCreate | CFile::modeWrite );
		int loop = 0;
		CString	name, code, info;
		while( pUserMacro->GetMacroInfo( loop, &name, &code, &info ) ) {
			File.Write( (const char *)name, name.GetLength() );
			File.Write( "|", 1 );
			File.Write( (const char *)code, code.GetLength() );
			File.Write( "|", 1 );
			File.Write( (const char *)info, info.GetLength() );
			File.Write( "|", 1 );
			loop++;
		}
	}	
}



/***************************************************************
[֐] OnOK i OK {^ENbNj
[  ] protected
[ @\ ] Iꂽ}N '$'ǉ Buff Ɋi[
         IB
***************************************************************/
void CMacroDlg::OnOK() 
{
	if( GetListBoxText(Buff+1) == TRUE ) {
		*Buff = '$';
	}else  *Buff = '\0'; 
	CDialog::OnOK();
}

/***************************************************************
[֐] OnDblclkMacroList1 i Xg{bNXE_uNbNj
[  ] protected
[ @\ ] OnOks
***************************************************************/
void CMacroDlg::OnDblclkMacroList1() 
{
	OnOK();	
}


/***************************************************************
[֐] OnSelchangeMacroList1 i Xg{bNX̑IύXj
[  ] protected
[ @\ ] IĂ}N̋@\\
***************************************************************/
void CMacroDlg::OnSelchangeMacroList1() 
{
	// TODO: ̈ʒuɃRg[ʒmnh̃R[hǉĂ
	if( GetListBoxText(Buff) == TRUE ) {
		CString code;
		pUserMacro->GetMacro( Buff, &code, &m_MacroInfo );
		UpdateData( FALSE );
	}
}

