/*=================================================
         Compute.cpp
=================================================*/
#include	"stdafx.h"
#include	"DT_.h"
			
#define		_RAD_INIT
#include	"Complx.h"

#include	"NODES.h"
#include	"UserMac.h"
#include	"Compute.h"
#include	"Data.h"


/***************************************************************
[ @\ ] p_t = 1 ̂Ƃ Xy[XA^u '*' ƂĈB
         p_t = 0 ̂Ƃ͂ȂB
***************************************************************/
int	p_t;

/***************************************************************
[֐] Compute(RXgN^)
[  ] public
[ @\ ] 
***************************************************************/
CCompute::CCompute()
{
}

/***************************************************************
[֐] ~Compute(fXgN^)
[  ] public
[ @\ ] 
***************************************************************/
CCompute::~CCompute()
{
}

/***************************************************************
[֐] GoCompute
[  ] public
[ @\ ]  pSorce Ŏw肳鐔vZČʂ Answer
         Ɋi[Bʏ TRUE vZɎsꍇ FALSE 
         ԂB  
***************************************************************/
BOOL	CCompute::GoCompute( CString str, complx* Answer )
{
	char	buf[256];
	strcpy(buf, (LPCSTR)str);
	SorceString = str;
	pSorceStr = buf;//(char *)(const char *)SorceString;

	Node	*root;
	BOOL	Error = TRUE;

	p_t = 0;
	token = Scan();
	do {
		if( (root = E()) && (token == EOLN || token == ';') ){
			*Answer = root->eval();
			Error = TRUE;
		}else {
			Error = FALSE;;
			if( root != NULL ) delete root;	break;
		}
		if( root != NULL ) delete root;
		p_t = 0;
	}while( (token = Scan()) != EOLN );
	return Error;
}



/***************************************************************
[֐] Add_NUm
[  ] protected
[ @\ ] pSorceStr 琔ǂݍ TokenStr ɓB
***************************************************************/
char	CCompute::Add_Num( Token c )
{
	do
		TokenStr += (char)c;
	while( isdigit( c = tolower( GetChar() ) ) );
	return	c;
}

/***************************************************************
[֐] Add_Char
[  ] protected
[ @\ ] pSorceStr Pǂݍ TokenStr tB
***************************************************************/
char	CCompute::Add_Char( Token c )
{
	TokenStr += (char)c;
	c = tolower( GetChar() );
	return	c;
}

/***************************************************************
[֐] Scan()
[  ] protected
[ @\ ]  pSorceStr Pg[Nǂݍł̎ނ
         ԂBA̎TokenStrɊi[B
         (g[N)      (߂l)    (TokenStr)
         L(+-/*,,,)	 ascii code	   Ȃ
         '$'			   USER		   Ȃ
         k		   EOLN		   Ȃ
         			   NUM		   i[
         			   ID		   i[
***************************************************************/
Token	CCompute::Scan()
{
	Token	c;
	TokenStr.Empty();
	while( 1 ){
		switch( c = tolower( GetChar() ) ){
			case	'+'	:	case	'-'	:	case	'*'	:	case	'/'	:
			case	'='	:	case	','	:	case	';' :
				p_t = 0;	return	c;
			case	'('	:	case	')'	:
				p_t = 1;	return	c;
			case	'\n':	case '\r':
				continue;
			case	' '	:	case	'\t'	:
				if(p_t){
					int	c1 = GetChar();	UnGetChar(c1);
					switch(c1){
						case	'+':	case	'-':	case	'*':	case	'/':
						case	'=':	case	',':	case	' ':
							continue;
						default	:
							p_t = 0;	return	c;
					}
				}	else	continue;
			case	'$':
				return	USER;
			case	'\0': 
				return	EOLN;
			default	:
				if( isdigit( c ) ){
					c = Add_Num( c );
					switch( c ){
						case	'.'	:
							c = Add_Char( c );
							if( isdigit( c ) )	c = Add_Num( c );
								else	if( c == '.')	return	BAD;
							if( c != 'e')break;
						case	'e'	:
							c = Add_Char( c );
							if( c == '-' )	c = Add_Char( c );
							if( (c == '-') || (c == 'e') ) return	BAD;
							c = Add_Num( c );
							break;
					}
					UnGetChar( c );
					p_t = 1;	return	NUM;
				}
				if( iscsymf( c )  ){
					do	{ 
						TokenStr += c;	
						c = tolower( GetChar() );	
					}while( iscsym( c )  );
					UnGetChar( c );
					p_t = 1;	return	ID;
				}
				return	BAD;
			}
	}
}


/***************************************************************
[֐] E
[  ] protected
[ @\ ] \́i{A[j
***************************************************************/
Node*	CCompute::E()
{
	Node	*root = T();
	while(1){
		switch( token ){
			case	'+'	:
				token = Scan();
				root = new	Plus(root, T() );
				break;
			case	'-'	:
				token = Scan();
				root = new	Minus(root,T() );
				break;
			default	:
				return	root;
		}
	}
}

/***************************************************************
[֐] T
[  ] protected
[ @\ ] \́i~Aj
***************************************************************/
Node*	CCompute::T()
{
	Node	*root = F();
	while(1){
		switch( token ){
			case	'*'	:	case	' '	:	case	'\t'	:
				token = Scan();
				root = new Times( root, F() );
				break;
			case	'/'	:
				token = Scan();
				root = new Div( root, F() );
				if( root->error() == FALSE ){ token = BAD; ErrorNumber = DIVISION_ERROR; }
				break;
			default	:
				return root;
		}
	}
}

/***************************************************************
[֐] F
[  ] protected
[ @\ ] \́iAϐA֐A,,,j
***************************************************************/
Node*	CCompute::F()
{
	CCompute	a;
	complx		cmp;
	Node	*root = NULL;
	switch( token ){
		case	NUM:
			root = new Num( atof( (const char *)TokenStr  ) );
			token = Scan();
			return root;
		case	'(':
			token = Scan();
			root = E();
			if( token == BAD ){ ErrorNumber = SYNTAX_ERROR; return root; }
			if( token != ')' ){ ErrorNumber = KAKKO_ERROR; token = BAD; return root; }
			token = Scan();
			return root;
		case	'-':
			token = Scan();
			return new Uminus( F() );
		case	ID:
			int	func_index;
			func_index = IsFunc( TokenStr, &token );
			switch( token ) {
				case	FUNC:	case	FUNC2:
					root = CallFunc( func_index );
					if( token != BAD ) token = Scan();  // G[ȊȌꍇ
					break;
				case	GVAR:
					root = new Id( (char *)(const char *)TokenStr );
					ErrorToken = TokenStr;
					if( (token = Scan()) == '=' ) {
						token = Scan();
						root = new	Assign((Id *)root, E());
						if( root->error() == FALSE ) {
							ErrorNumber = ASSIGN_ERROR;
							token = BAD;	break;  // oȂ
						}
					}else {
						root = new Times(root, new Num( 1.0 ) );	break;
					}
				default:	break;
			}
			return root;

		case	USER:
			if( (token = Scan()) != ID )
			{ ErrorNumber = MACRO_ERROR1; token = BAD;	return root; }
			root = CallUserMacro( TokenStr );					
			if( root == NULL ){ token = BAD;	return root; }
			token = Scan();
			return root;
		default	:
			ErrorNumber = SYNTAX_ERROR;
			token = BAD;
			return root;
	}
	token = BAD;
	return	root;
}


/***************************************************************
[֐] IsFunc
[  ] protected
[ @\ ] TokenStr ֐ǂʁBʂtokenɊi[B
         ֐łȂƂ token  GVAR(ϐ)i[B
		 ߂lƂĉ̊֐킩u֐ԍvԂB
***************************************************************/
int		CCompute::IsFunc( CString pIdName, int* token )
{
	int loop;
	*token = FUNC;	//P
	for( loop = 0; *(FuncTable1[ loop ].name); loop++ )
		if( pIdName.Compare( FuncTable1[ loop ].name ) == 0 )return loop;

	*token = FUNC2;	//Q
	for( loop = 0; *(FuncTable2[ loop ].name); loop++ )
		if( pIdName.Compare( FuncTable2[ loop ].name ) == 0 )return loop;

	*token = GVAR;	//ϐ 
	return	0;		
}

/***************************************************************
[֐] CallFunc
[  ] protected
[ @\ ] ֐ԍ FuncIndex Ŏw肳֐ĂяoB
         ֐łȂƂ token  GVAR(ϐ)i[B
		 ߂lƂĉ̊֐킩u֐ԍvԂB
***************************************************************/
Node*	CCompute::CallFunc(int  FuncIndex )
{
	const	ARG_TYPE1 =  0, ARG_TYPE2 = 1;
	int		loop = 0;
	int		ParamNum = token - (int)FUNC;
	Node	*root, *pParam[ PARAM_MAX ];					

	if( (token = GetChar()) != '(' ) {
		ErrorNumber = FUNC_ERROR2;
		token = BAD;	return	NULL;
	}

	do{
		token = Scan();
		pParam[ loop ] = E();
		if( token != ',' &&  token != ')' )	{
			ErrorNumber = FUNC_ERROR1;
			token = BAD; return NULL;
		}
	}while(  ParamNum > loop++  );
	if( token != ')' ){ ErrorNumber = FUNC_ERROR1;	token = BAD; return NULL; }

	// ̌ŃRXgN^Ăѕ
	switch( ParamNum ) {
		case ARG_TYPE1:	root = new Func( FuncIndex, pParam[0] );	break;			//P
		case ARG_TYPE2:	root = new Func( FuncIndex, pParam[0], pParam[1] );	break;	//Q
		default:
			token = BAD;
			ErrorNumber = FUNC_ERROR1;
			return NULL;	// ̐ȂiG[j 		
	}
	return	root;
}

/***************************************************************
[֐] CallUserMacro
[  ] protected
[ @\ ] name }Nǂ`FbNA}NsCall
         UserMacroSubĂяoB
		 słꍇ͌vZʂi[NumIuWFNg̃|C^
		 AȊONULLԂB
***************************************************************/
Node*	CCompute::CallUserMacro( CString name  )
{
	complx		value;
	CString		MacroCode;
	CCompute	Com;

	if( m_UserMacro.GetMacro( name, &MacroCode ) == TRUE ) {
		if( MacroLoopCheck( name ) == TRUE ) {
			MacroHistCnt++;
			if( Com.GoCompute( (char *)(const char *)MacroCode, &value ) == TRUE ){
				MacroHistCnt--;
				return new Num( value );
			}else
				return NULL;
		}else{
			 ErrorNumber = MACRO_ERROR2;
			 return NULL;
		}
	}else {
		ErrorNumber = MACRO_ERROR1;
		return NULL;
	}
}

/***************************************************************
[֐] MacroLoopCheck
[  ] protected
[ @\ ] MacroNameŎ}NċA邩ǂ`FbNB
         Ȃꍇ TRUE AċAꍇƊKw MACRO_LOOP_MAX
		 [Ȃꍇ FALSE Ԃ܂B
***************************************************************/
BOOL	CCompute::MacroLoopCheck( CString MacroName )
{
	for( int loop = 0; loop < MacroHistCnt; loop++ ) {
		if( MacroName == MacroHistory[loop] )return FALSE;
	}
	MacroHistory[ MacroHistCnt ] = MacroName;
	if( MacroHistCnt < MACRO_LOOP_MAX )
		return TRUE;
	else
		return FALSE;
}

