/*=====================================================
       CUserMacroNX      
=====================================================*/
#include	"Stdafx.h"
#define		_INIT_MACRO
#include	"UserMac.h"



/***************************************************************
[֐] CheckName
[  ] protected
[ @\ ] }Nǂ`FbN
***************************************************************/
BOOL	CUserMacro::CheckName( CString Name )
{
	char*	p = (char *)(const char *)Name;
	if( isalpha( *p ) == 0 )return FALSE;

	p++;
	while( *p ) {
		if( iscsym( *p ) == 0 )return FALSE;
		p++;
	}
	return	TRUE;
}

/***************************************************************
[֐] Find
[  ] protected
[ @\ ] }NXg̒ name ƓÕ}N
         |C^ԂBꍇ NULL ԂB
***************************************************************/
CUserCode*	CUserMacro::Find( CString name )
{
	for( CUserCode* p = Macro_Symtab.pBefour;  p;  p = p->pBefour ) {
		if( p->Name == name )return p;
	}
	return	NULL;
}

/***************************************************************
[֐] MakeMacro
[  ] protected
[ @\ ] name Ɠ̃}Nꍇ code, info ōXVA
         ꍇ͐VKɍ쐬B
         ʏ TRUE ԂAO`FbNɂЂ FALSE Ԃ
***************************************************************/
BOOL	CUserMacro::MakeMacro( CString name, CString code, CString info )
{
	CUserCode*	p;
	if( CheckName(name) == TRUE ) {
		if( 	(p = Find(name)) == NULL ) {
			Macro_Symtab.pBefour = new CUserCode( name, code, info, Macro_Symtab.pBefour );
		}else {
			p->Code = code;
			p->Information = info;
		}
		return	TRUE;
	}
	return	FALSE;
}

/***************************************************************
[֐] GetMacro
[  ] protected
[ @\ ] name Ŏw肳}ÑR[hA@\ code, info
         Ɋi[Bʏ TRUE A}NȂ
         FALSE ԂBA
***************************************************************/
BOOL	CUserMacro::GetMacro( CString name, CString* code, CString* info )
{
	CUserCode*	p;
	if( (p = Find(name)) ) {
		*code = p->Code;
		if( info != NULL )*info = p->Information;
		return	TRUE;
	}else return	FALSE;
}

/***************************************************************
[֐] DeleteMacro
[  ] protected
[ @\ ] name Ŏw肳}NXg폜B
         ʏ TRUE A}NȂ FALSE ԂBA
***************************************************************/
BOOL	CUserMacro::DeleteMacro( CString name )
{
	CUserCode*   p	 = Macro_Symtab.pBefour;
	CUserCode* pBack = &Macro_Symtab;

	while( p ) {
		if( p->Name == name ) {
			pBack->pBefour = p->pBefour;
			p->pBefour = NULL;
			delete	p;	return	TRUE;
		}
		pBack = p;	p = p->pBefour;
	}
	return	FALSE;
}

/***************************************************************
[֐] GetMacroInfo
[  ] protected
[ @\ ] }NXg̓ index ڂ̃}N name,
         code, info Ɋi[Bʏ TRUE }N
		 FALSE ԂB
***************************************************************/
BOOL	CUserMacro::GetMacroInfo( int index, CString* name, CString* code, CString* info )
{
	CUserCode*   p = &Macro_Symtab;
	for( int loop = 0; loop <= index; loop++ )
		if( (p = p->pBefour) == NULL )return FALSE;
	*name = p->Name;	*code = p->Code;
	if( info != NULL )*info = p->Information;	
	return	TRUE;
}


